c
c
c
      subroutine conturs(plot2d,title,
     %   ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax)
      include 'SPRINC'
      parameter (mcntur=50)
      character*72 string,title
      real rmaj(nchi,npsi),zed(nchi,npsi),hpsi(nchi,npsi),
     %     hchi(nchi,npsi),psi(npsi),chi(nchi),pquad(npsi),pcoef(nchi),
     %     plot2d(nchi+1,npsi),rmaj2d(nchi+1,npsi),zed2d(nchi+1,npsi),
     %     raymaj(nchi+npsi),rayzed(nchi+npsi),
     %     clevel(mcntur)
      common /metric/ rmaj,zed,hpsi,hchi,psi,chi,pquad,pcoef
      data ncntur /10/	  ! actual # of contours to plot ( <= mcntur)
c
      npsim1=npsi-1
      nchip1=nchi+1
c
c CONTUR routine doesn't work unless you have already set up the
c plotting area and the virtual to screen map.  Do this by first
c plotting the vacuum vessel wall (we could have instead called
c the AGRAPH routine to prepare for CONTUR, but AGRAPH doesn't allow
c to set the x and y limits exacatly, not with xneat/yneat, not with
c agixnt/agiynt).
c
      call initt(960)
      call binitt
	call fpgrlab
      call npts(nchip1)
      do 98 i=1,nchi
      raymaj(i)=rmaj(i,npsi)
   98 rayzed(i)=zed(i,npsi)
      raymaj(nchip1)=raymaj(1)
      rayzed(nchip1)=rayzed(1)
 
        call xneat(0)
        call yneat(0)
        call slimx(150,725)
        call slimy(125,700)
	zRav=(rmjmax+rmjmin)/2
	zrhw=(rmjmax-rmjmin)/2
	zrhh=(zedmax-zedmin)/2
	zsiz=1.1*max(zrhw,zrhh)
	call dlimx(zRav-zsiz,zRav+zsiz)
	call dlimy(-zsiz,zsiz)
        call xfrm(2)
        call yfrm(2)
        call check(raymaj,rayzed)
        call dsplay(raymaj,rayzed)
        call frame  !@
c@      call dframe
        call agtchs('Rmajor (m)')
        call agtcvs('Y (m)')
 
      dlwall=.005*zedmax
      do 99 i=1,nchi
      dgrid=sqrt((rmaj(i,npsi)-rmaj(i,npsim1))**2+
     %                                   (zed(i,npsi)-zed(i,npsim1))**2)
      raymaj(i)=raymaj(i)+dlwall*(rmaj(i,npsi)-rmaj(i,npsim1))/dgrid
   99 rayzed(i)=rayzed(i)+dlwall*(zed(i,npsi)-zed(i,npsim1))/dgrid
      raymaj(nchip1)=raymaj(1)
      rayzed(nchip1)=rayzed(1)
      call cplot(raymaj,rayzed)
 
c now plot the data:
      call npts(nchip1*npsi)
      do 61 j=1,npsi
      do 60 i=1,nchi
      rmaj2d(i,j)=rmaj(i,j)
   60 zed2d(i,j)=zed(i,j)
      rmaj2d(nchip1,j)=rmaj2d(1,j)
   61 zed2d(nchip1,j)=zed2d(1,j)
      pltmin=1.e38
      pltmax=-1.e38
      call mnmx(plot2d,pltmin,pltmax)
      dcont=(pltmax-pltmin)/float(ncntur)
      icneg=-ifix(pltmin/dcont+.5)
      do 97 i=1,ncntur
   97 clevel(i)=(float(i-icneg)-.5)*dcont
      k1=ncntur
      k2=icneg+1
c      call agraph(ileft,iright,idown,iup,rmjmin,rmjmax,zedmin,zedmax,
c     %                                                 'Rmajor$','Z$')
      call contur(k1,clevel,k2,
     %                   plot2d,nchip1,rmaj2d,1,nchip1,1,zed2d,1,npsi,1)
 
      call agtcgt(iup+60,title,0)
      write (string,665) pltmin,pltmax
  665 format('min=',1pe10.3,', max=',1pe9.3,' $')
      call agtcgt(iup+35,string,0)
	call upause(0)
	call finitt(0,0)
c
      return
      end
