	subroutine fpwruf
c
c write ufiles of ln(fcx(energy,time)) for each sightline:
C
C     COMMON BLOCKS
C
	include 'FPPCOM'
 
	character string*80
 
	real tmplo(0:maxtim) !time axis for plots
	real zulnf(maxen,0:maxtim) !temp storage for ln(fcx(Energy,time))
				 ! for ufiles
        character flab*30,xlab*30,ylab*30,chdate*10 !ufile labels
	character fprnam*256,ufname*20
 
! function to index into SPECTR(ien,jsightline,ntime):
! (ntime=0,1,...,loomax/snkip)
	indspe(i,j,n)=1+(i-1+nencx*(j-1+nline*n))
 
c don't write out nonexistant Ufiles:
	if (Ldir .eq. -1 .or. nline .le. 0) return
 
C
c write a ufile of ln(fcx(energy,time)):
C
! define list of times at which CX spectra where calculated:
	do itt=0,loomax/nSkipCX
	tmplo(itt)=Timmy(itt*nSkipCX)
	enddo
 
! write 1 u-file for each tangency radius:
	do islin=1,nline
	write(string,'(i6)') int(tans(islin))
	iunit=37
	do i=6,1,-1
	if(string(i:i) .ne. ' ')istst=i
	enddo
	ufname=runname(1:lrunname)//'_'//string(istst:6)
	call ufsetr(iunit,ufname,'fcx ',' ',' ')
	call ufnsho(iunit)
 
!define zulnf
	do i=1,maxen
	do j=0,loomax/nSkipCX
	zulnf(i,j)=-100
	if(spectr(indspe(i,islin,j)) .gt. 0.0)
	1   zulnf(i,j)=alog(spectr(indspe(i,islin,j))*1.0e15)
	enddo
	enddo
 
! define ufiles labels:
        flab(1:20)='ln(f_CX)'
	write(flab(1:20),7)int(tans(islin))
7	format('ln(fcx)',i5,' cm Rtan')
        flab(21:30)='ppl''s'
        xlab(1:10)='Energy'
        xlab(21:30)='eV'
        ylab(1:10)='time'
        ylab(21:30)='seconds'
 
        call ufopwr(iunit,1,ier) !open ufile for write access
	call c9date(chdate)
        call uf2dwr(iunit,'fpp',chdate,zulnf,maxen,ener,nencx,tmplo,
	1   loomax/nSkipCX+1,0,flab,xlab,ylab,0,dum,dum,ier)
        call ufclos(iunit)
	end do !end of loop over islin sightlines
c ******** end of ufiles writing
 
	return
	end
