      subroutine powers(w,akzt,ichi,jpsi,zdRovR,
     %                  pwrden,pwrspc,pwrmc,pwre,pwrh,cnprp2,emtoep)
      include 'SPRINC'
      real awi(ionmax),qi(ionmax),densi(ionmax),tempi(ionmax)
      complex hphi(nchi*npsi),echi(nchi*npsi),epsi(nchi*npsi),
     %        tplus0(ionmax+1),tplus1(ionmax+1),
     %        tmins0(ionmax+1),tmins1(ionmax+1),alpha(ionmax+1),
     %        pwre,pwrh,pwr0,pwr1,pwrden,pwrmc,pwrspc(ionmax+1),
     %        ckrt(4),cnprp2,cnmag2,tprp0,tcrs0,alp,tprp1,tcrs1,
     %        tprpwk,tcrswk,disp,eplus,emins,emtoep
      common /spfldcom/ hphi,echi,epsi
c
c     POWERS finds the local mode converted power and absorption on
c     each plasma species.
c
      ntot=nchi*npsi
      norigl=nchi
      nbodyf=nchi+1
c
      i=ichi+(jpsi-1)*nchi
c
      ako2=1.11265e-17*w**2
      hnorm=376.730**2
      disp=cmplx(0.,-5.56325e-11*w)
      anzt2=akzt**2/ako2
c
      call plasma(bmag,dense,tempe,nions,awi,qi,densi,tempi,ichi,jpsi)
c
      call sptensor(tplus0,tplus1,tmins0,tmins1,alpha,alfven,
     %       w,zdRovR,bmag,dense,tempe,nions,awi,qi,densi,tempi,akzt)
c
      call root(ckrt,
     %     w,akzt,nions,tplus0,tplus1,tmins0,tmins1,alpha,alfven)
c
      nspec=nions+1
c      cnprp2=ckrt(1)**2/cmplx(ako2,0.)
c GWH: ROOT modified to give kx**2 rather than kx:
      cnprp2=ckrt(1)/cmplx(ako2,0.)
      cnmag2=(1.,0.)*cabs(cnprp2)
      tprp0=(0.,0.)
      tcrs0=(0.,0.)
      tprp1=(0.,0.)
      tcrs1=(0.,0.)
      alp=(0.,0.)
      do 15 isp=1,nspec
      tprp0=tprp0+tplus0(isp)+tmins0(isp)
      tcrs0=tcrs0+tplus0(isp)-tmins0(isp)
      tprp1=tprp1+tplus1(isp)+tmins1(isp)-alpha(isp)
      tcrs1=tcrs1+tplus1(isp)-tmins1(isp)
   15 alp=alp+alpha(isp)
      tprpwk=((1.,0.)-cmplx(anzt2,0.)+tprp0+cnprp2*tprp1)/((1.,0.)-alp)
      tcrswk=(tcrs0+cnprp2*tcrs1)/((1.,0.)-alp)
      eplus=cmplx(cabs(epsi(i)+(0.,1.)*echi(i))**2,0.)
      emins=cmplx(cabs(epsi(i)-(0.,1.)*echi(i))**2,0.)
c
c     calculate powers
      pwre=disp*cmplx(1.-anzt2,0.)*(.5,0.)*(eplus+emins)
      pwrh=disp*cmplx(hnorm,0.)*hphi(i)*conjg(hphi(i))
      pwr0=disp*( tprp0*(echi(i)*conjg(echi(i))+epsi(i)*conjg(epsi(i)))
     %   +(0.,1.)*tcrs0*(echi(i)*conjg(epsi(i))-epsi(i)*conjg(echi(i))))
      pwr1=disp*( tprp1*(echi(i)*conjg(echi(i))+epsi(i)*conjg(epsi(i)))
     %   +(0.,1.)*tcrs1*(echi(i)*conjg(epsi(i))-epsi(i)*conjg(echi(i))))
      pwrden=pwrh+(pwre+pwr0+cnprp2*pwr1)/((1.,0.)-alp)
      pwrmc=(0.,0.)
      do 20 isp=1,nspec
      pwrspc(isp)=disp*(eplus*(tplus0(isp)+cnmag2*tplus1(isp))
     %                 +emins*(tmins0(isp)+cnmag2*tmins1(isp))
     %                 -.5*(eplus+emins)*cnmag2*alpha(isp))
     %                 +alpha(isp)*(pwre+pwr0+cnmag2*pwr1)/((1.,0.)-alp)
   20 pwrmc=pwrmc+disp*(eplus*(cnprp2-cnmag2)*tplus1(isp)
     %                 +emins*(cnprp2-cnmag2)*tmins1(isp)
     %                 -.5*(eplus+emins)*(cnprp2-cnmag2)*alpha(isp))
     %                 +alpha(isp)*(cnprp2-cnmag2)*pwr1/((1.,0.)-alp)
      emtoep=(tprpwk+(0.,1.)*tcrswk)/(tprpwk-(0.,1.)*tcrswk)
c
      return
      end
