C----------------------------------------------------------------------
C  ABORT A PROGRAM AFTER A FATAL ERROR CONDITION IS DETECTED.
C
	Subroutine Aborter(ilunerr,ierrmsg)
c
c input: ilunerr  fortran lun to write error messages to.
c	 ierrmsg  An error message to write ilunerr
c
c	The advantage of using this subroutine is that it will
c	generate a traceback showing the chain of subroutines which
c	eventually bombed, and it forces an arithmetic error which
c	the job control system can detect as a fatal error.
c	(This is a version of subroutine abortr, but it can be used
c	by any program, not just by transp, since it doesn't use the
c	transp common block.
C
C
	character ierrmsg*(*)
	common /abortcmn/ zz0
 
	write(ilunerr,1001)
1001	FORMAT(//
	1   ' %ABORTER:  ** FATAL ERROR.  ABORT SUBROUTINE CALLED **'
	1   //)
 
	write(ilunerr,1002)ierrmsg
1002	format(1x,a,//)
 
C^	  Z0=zz0		    !^
C^	  Z1=SQRT(Z0)		    !^
C^	  Z2=SQRT(-Z0)		    !^
C^	  Z22=1.0/(Z1**2+Z2**2)	    !^
C^	  zz0=Z22		    !^
 
	CALL EXIT(1)	!^
 
	write(ilunerr,1010) zz0
1010	FORMAT(' ?ABORTER-- ZZ0= ',1PE11.4,' AND STILL EXECUTING...')
	STOP
	END
