	subroutine plotf
c--draw contour plots of f(vpar,vperp)
c--modified for batch mode use Nov. 1, 1983
 
c
c	common blocks
c
	include 'FPPCOM'
 
c--data needed for contour plots:
c--see sg documentation on contour plots.
	real vpar(-1:maxen+1,0:maxxsi+1)
	real vperp(-1:maxen+1,0:maxxsi+1)
	real concon(60)	!the number of contours must be less than 60
	character*80 xlabel,answer
 
c--find max data point:
	smax=0.0
	do 7 i=0,maxen
	do 7 j=1,maxxsi
7	if(smax .lt. f1(i,j))smax=f1(i,j)
 
	enlim=enerev(maxen)	!upper energy limit for the graph (eV)
 
c--contour control
	data nconto /3/
	data ndecad /5/
10	dffrac=.1**(1./nconto)
	nlines=nconto*ndecad+1
	if(nlines .gt. 60)nlines=60
	concon(1)=smax
	do 170 i=2,nlines
170	concon(i)=concon(i-1)*dffrac
 
	do 200 ien=0,maxen
	do 200 ian=1,maxxsi
	eovn=enerev(ien)/enlim
	vpar(ien,ian)=xsi(ian)*sqrt(eovn)
200	vperp(ien,ian)=sqrt(eovn)*(1.0-xsi(ian)**2)**0.5

	call initt(240)
	emaxim=enlim/1000.
	call agraph(125,975,150,575,-1.,1.,0.,1.,'Vpar$','Vperp$')
 
	call contur(nlines,concon,0,f1,maxen+3,
	1	vpar,2,maxen+2,1,vperp,2,maxxsi+1,1)

	call fpgrlab
	timm=time*1000.
	write(xlabel,250)timm,nshe
250	format(' f(Vpar,Vperp) at t=',f12.4,' msec,  shell # =',i2,'$')
	call AGTcgt(655,xlabel)
	write(xlabel,251)nconto,emaxim
251	format(' ',I5,
     >         ' contours per decade.  Max velocity equivalent to',
     >         f12.3,' kev.$')
	call AGTcgt(615,xlabel)
 
	call upause(0)
 
c--if we are running in batch mode, skip the interactive part:
	if(batchm)return
	write(lsysout,300)
300	format(' plot again?',$)	!@
C@300	format(' plot again?')
	read(lsysin,301)answer
301	format(a1)
	if(answer .eq. 'Y' .or. answer .eq. 'y')then		
	call prompt('# of contours per decade',nconto,'i')
	call prompt('# of decades',ndecad,'i')
	call prompt('upper energy limit for plot (eV)',enlim,'f')
	go to 10
	endif
	call erase
900	return
	end
